public class posSigInpBlackout implements input{

public input base;
public int blackout;
public int counter;
public int startBlackout;
public int blackoutLength;
public int interval;
public static java.util.Random rand=main.rand;


public void initRand(long seed){
rand=new java.util.Random(seed);
}

/*parameters:
wavelength - as in other input functions
blackoutLength - how long does a blackout last once started
interval - how often should a blackout occur (inside this interval one blackout will occur at some random point in time)
NB it must hold: blackoutLength >> interval
*/
public posSigInpBlackout(int wavelength,int blackoutLength,int interval){
base=new posSigInp(wavelength);
blackout=0;
counter=0;
this.blackoutLength=blackoutLength;
this.interval=interval;
}

//as above but with noise this time (param: standard deviation of gaussian white noise)
public posSigInpBlackout(int wavelength,double stdDev, int blackoutLength,int interval){
this(wavelength,blackoutLength,interval);
base=new posSigInp(wavelength,stdDev);//noise
}

public double getVal(){
if(counter%interval==0){ //determine starting point of next blackout
  startBlackout=rand.nextInt(interval-blackoutLength);
}
if(startBlackout==0)
  blackout=blackoutLength;
startBlackout--;
counter++;
if(blackout>0){
  blackout--;
  base.getVal(); //necessary to increase counter in base!!!
  return 0.0;
}
else
  return base.getVal();
}

} 
